diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/nix-vector-routing/examples/nms-p2p-nix.cc ns-3.36/src/nix-vector-routing/examples/nms-p2p-nix.cc
--- ns-3.35/src/nix-vector-routing/examples/nms-p2p-nix.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/nix-vector-routing/examples/nms-p2p-nix.cc	2022-04-30 18:23:58.114734600 -0700
@@ -38,10 +38,8 @@
  * to make very large simulations.
  */
 
-// for timing functions
-#include <cstdlib>
-#include <sys/time.h>
-#include <fstream>
+#include <chrono>
+#include <sstream>
 
 #include "ns3/core-module.h"
 #include "ns3/internet-module.h"
@@ -55,11 +53,6 @@
 
 using namespace ns3;
 
-typedef struct timeval TIMER_TYPE;
-#define TIMER_NOW(_t) gettimeofday (&_t,NULL);
-#define TIMER_SECONDS(_t) ((double)(_t).tv_sec + (_t).tv_usec*1e-6)
-#define TIMER_DIFF(_t1, _t2) (TIMER_SECONDS (_t1)-TIMER_SECONDS (_t2))
-
 NS_LOG_COMPONENT_DEFINE ("CampusNetworkModel");
 
 void Progress ()
@@ -157,8 +150,8 @@
 int
 main (int argc, char *argv[])
 {
-  TIMER_TYPE t0, t1, t2;
-  TIMER_NOW (t0);
+  auto t0 = std::chrono::steady_clock::now ();
+
   std::cout << " ==== DARPA NMS CAMPUS NETWORK SIMULATION ====" << std::endl;
   // LogComponentEnable ("OnOffApplication", LOG_LEVEL_INFO);
 
@@ -687,8 +680,7 @@
     }
 
   std::cout << "Created " << NodeList::GetNNodes () << " nodes." << std::endl;
-  TIMER_TYPE routingStart;
-  TIMER_NOW (routingStart);
+  auto routingStart = std::chrono::steady_clock::now ();
 
   if (nix)
     {
@@ -702,25 +694,28 @@
       Ipv4GlobalRoutingHelper::PopulateRoutingTables ();
     }
 
-  TIMER_TYPE routingEnd;
-  TIMER_NOW (routingEnd);
-  std::cout << "Routing tables population took " 
-       << TIMER_DIFF (routingEnd, routingStart) << std::endl;
+  auto routingEnd = std::chrono::steady_clock::now ();
+  std::cout << "Routing tables population took "
+            << std::chrono::duration_cast<std::chrono::milliseconds> (routingEnd - routingStart).count () << "ms"
+            << std::endl;
 
   Simulator::ScheduleNow (Progress);
   std::cout << "Running simulator..." << std::endl;
-  TIMER_NOW (t1);
+  auto t1 = std::chrono::steady_clock::now ();
   Simulator::Stop (Seconds (100.0));
   Simulator::Run ();
-  TIMER_NOW (t2);
+  auto t2 = std::chrono::steady_clock::now ();
   std::cout << "Simulator finished." << std::endl;
   Simulator::Destroy ();
 
-  double d1 = TIMER_DIFF (t1, t0), d2 = TIMER_DIFF (t2, t1);
-  std::cout << "-----" << std::endl << "Runtime Stats:" << std::endl;
-  std::cout << "Simulator init time: " << d1 << std::endl;
-  std::cout << "Simulator run time: " << d2 << std::endl;
-  std::cout << "Total elapsed time: " << d1+d2 << std::endl;
+  auto d1 = std::chrono::duration_cast<std::chrono::seconds>(t1 - t0);
+  auto d2 = std::chrono::duration_cast<std::chrono::seconds>(t2 - t1);
+
+  std::cout << "-----" << std::endl
+            << "Runtime Stats:" << std::endl;
+  std::cout << "Simulator init time: " << d1.count () << "s" << std::endl;
+  std::cout << "Simulator run time: " << d2.count () << "s" << std::endl;
+  std::cout << "Total elapsed time: " << (d1 + d2).count () << "s" << std::endl;
 
   delete[] nodes_netLR;
   return 0;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/nix-vector-routing/helper/nix-vector-helper.cc ns-3.36/src/nix-vector-routing/helper/nix-vector-helper.cc
--- ns-3.35/src/nix-vector-routing/helper/nix-vector-helper.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/nix-vector-routing/helper/nix-vector-helper.cc	2022-04-30 18:23:58.118734800 -0700
@@ -33,7 +33,7 @@
 NixVectorHelper<T>::NixVectorHelper ()
 {
   std::string name = (IsIpv4::value ? "Ipv4" : "Ipv6");
-  m_agentFactory.SetTypeId (("ns3::" + name + "NixVectorRouting").c_str ());
+  m_agentFactory.SetTypeId ("ns3::" + name + "NixVectorRouting");
 }
 
 template <typename T>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/nix-vector-routing/model/nix-vector-routing.cc ns-3.36/src/nix-vector-routing/model/nix-vector-routing.cc
--- ns-3.35/src/nix-vector-routing/model/nix-vector-routing.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/nix-vector-routing/model/nix-vector-routing.cc	2022-04-30 18:23:58.118734800 -0700
@@ -44,6 +44,10 @@
 template <typename T>
 bool NixVectorRouting<T>::g_isCacheDirty = false;
 
+// Epoch starts from one to make it easier to spot an uninitialized NixVector during debug.
+template <typename T>
+uint32_t NixVectorRouting<T>::g_epoch = 1;
+
 template <typename T>
 typename NixVectorRouting<T>::IpAddressToNodeMap NixVectorRouting<T>::g_ipAddressToNodeMap;
 
@@ -56,7 +60,7 @@
 {
   std::string Tname = GetTypeParamName<NixVectorRouting<T> > ();
   std::string name = (Tname == "Ipv4RoutingProtocol" ? "Ipv4" : "Ipv6");
-  static TypeId tid = TypeId (("ns3::" + name + "NixVectorRouting").c_str ())
+  static TypeId tid = TypeId ("ns3::" + name + "NixVectorRouting")
     .SetParent<T> ()
     .SetGroupName ("NixVectorRouting")
     .template AddConstructor<NixVectorRouting<T> > ()
@@ -183,6 +187,7 @@
   NS_LOG_FUNCTION (this << source << dest << oif);
 
   Ptr<NixVector> nixVector = Create<NixVector> ();
+  nixVector->SetEpoch (g_epoch);
 
   // not in cache, must build the nix vector
   // First, we have to figure out the nodes 
@@ -271,35 +276,6 @@
 
 template <typename T>
 bool
-NixVectorRouting<T>::BuildNixVectorLocal (Ptr<NixVector> nixVector)
-{
-  NS_LOG_FUNCTION_NOARGS ();
-
-  uint32_t numberOfDevices = m_node->GetNDevices ();
-
-  // here we are building a nix vector to 
-  // ourself, so we need to find the loopback 
-  // interface and add that to the nix vector
-
-  for (uint32_t i = 0; i < numberOfDevices; i++)
-    {
-      uint32_t interfaceIndex = (m_ip)->GetInterfaceForDevice (m_node->GetDevice (i));
-      IpInterfaceAddress ifAddr = m_ip->GetAddress (interfaceIndex, 0);
-      IpAddress ifAddrValue = ifAddr.GetAddress ();
-      if (ifAddrValue.IsLocalhost ())
-        {
-          NS_LOG_LOGIC ("Adding loopback to nix.");
-          NS_LOG_LOGIC ("Adding Nix: " << i << " with " << nixVector->BitCount (numberOfDevices) 
-                                       << " bits, for node " << m_node->GetId ());
-          nixVector->AddNeighborIndex (i, nixVector->BitCount (numberOfDevices));
-          return true;
-        }
-    }
-  return false;
-}
-
-template <typename T>
-bool
 NixVectorRouting<T>::BuildNixVector (const std::vector< Ptr<Node> > & parentVector, uint32_t source, uint32_t dest, Ptr<NixVector> nixVector) const
 {
   NS_LOG_FUNCTION (this << parentVector << source << dest << nixVector);
@@ -710,6 +686,24 @@
 
   NS_LOG_DEBUG ("Dest IP from header: " << destAddress);
 
+  if (destAddress.IsLocalhost ())
+    {
+      rtentry = Create<IpRoute> ();
+      rtentry->SetSource (IpAddress::GetLoopback ());
+      rtentry->SetDestination (destAddress);
+      rtentry->SetGateway (IpAddress::GetZero ());
+      for (uint32_t i = 0 ; i < m_ip->GetNInterfaces (); i++)
+        {
+          Ptr<LoopbackNetDevice> loNetDevice = DynamicCast<LoopbackNetDevice> (m_ip->GetNetDevice (i));
+          if (loNetDevice)
+            {
+              rtentry->SetOutputDevice (loNetDevice);
+              break;
+            }
+        }
+      return rtentry;
+    }
+
   if constexpr (!IsIpv4::value)
     {
       /* when sending on link-local multicast, there have to be interface specified */
@@ -735,9 +729,11 @@
       // Build the nix-vector, given this node and the
       // dest IP address
       nixVectorInCache = GetNixVector (m_node, destAddress, oif);
-
-      // cache it
-      m_nixCache.insert (typename NixMap_t::value_type (destAddress, nixVectorInCache));
+      if (nixVectorInCache)
+      {
+        // cache it
+        m_nixCache.insert (typename NixMap_t::value_type (destAddress, nixVectorInCache));
+      }
     }
 
   // path exists
@@ -863,6 +859,7 @@
           if (!lcb.IsNull ())
             {
               NS_LOG_LOGIC ("Local delivery to " << destAddress);
+              p->SetNixVector (nullptr);
               lcb (p, header, iif);
               return true;
             }
@@ -905,6 +902,14 @@
   // If nixVector isn't in packet, something went wrong
   NS_ASSERT (nixVector);
 
+  if (nixVector->GetEpoch () != g_epoch)
+    {
+      NS_LOG_LOGIC ("NixVector epoch mismatch (" << nixVector->GetEpoch () << " Vs " << g_epoch
+                                                 << ") - rebuilding it");
+      nixVector = GetNixVector (m_node, destAddress, 0);
+      p->SetNixVector (nixVector);
+    }
+
   // Get the interface number that we go out of, by extracting
   // from the nix-vector
   if (m_totalNeighbors == 0)
@@ -989,9 +994,14 @@
             {
               *os << *(it->second) << std::endl;
             }
+          else
+            {
+              *os << "-" << std::endl;
+            }
         }
     }
-  *os << "IpRouteCache:" << std::endl;
+  
+  *os << "IpRouteCache:" << std::endl;  
   if (m_ipRouteCache.size () > 0)
     {
       *os << std::setw (30) << "Destination";
@@ -1249,8 +1259,8 @@
   *os << std::resetiosflags (std::ios::adjustfield) << std::setiosflags (std::ios::left);
   *os << "Time: " << Now().As (unit)
       << ", Nix Routing" << std::endl;
-  *os << "Route Path: ";
-  *os << "(Node " << source->GetId () << " to Node " << destNode->GetId () << ", ";
+  *os << "Route path from ";
+  *os << "Node " << source->GetId () << " to Node " << destNode->GetId () << ", ";
   *os << "Nix Vector: ";
 
   // Check the Nix cache
@@ -1264,8 +1274,6 @@
       // Build the nix-vector, given the source node and the
       // dest IP address
       nixVectorInCache = GetNixVector (source, dest, nullptr);
-      // cache it
-      m_nixCache.insert (typename NixMap_t::value_type (dest, nixVectorInCache));
     }
 
   if (nixVectorInCache || (!nixVectorInCache && source == destNode))
@@ -1282,7 +1290,7 @@
 
           *os << *nixVector;
         }
-      *os << ")" << std::endl;
+      *os << std::endl;
 
       if (source == destNode)
         {
@@ -1360,6 +1368,7 @@
   if (g_isCacheDirty)
     {
       FlushGlobalNixRoutingCache ();
+      g_epoch++;
       g_isCacheDirty = false;
     }
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/nix-vector-routing/model/nix-vector-routing.h ns-3.36/src/nix-vector-routing/model/nix-vector-routing.h
--- ns-3.35/src/nix-vector-routing/model/nix-vector-routing.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/nix-vector-routing/model/nix-vector-routing.h	2022-04-30 18:23:58.118734800 -0700
@@ -219,13 +219,6 @@
   bool BuildNixVector (const std::vector< Ptr<Node> > & parentVector, uint32_t source, uint32_t dest, Ptr<NixVector> nixVector) const;
 
   /**
-   * Special variation of BuildNixVector for when a node is sending to itself
-   * \param [out] nixVector the NixVector to be used for routing
-   * \returns true on success, false otherwise.
-   */
-  bool BuildNixVectorLocal (Ptr<NixVector> nixVector);
-
-  /**
    * Simply iterates through the nodes net-devices and determines
    * how many neighbors the node has.
    * \param [in] node node pointer
@@ -455,6 +448,11 @@
    */
   static bool g_isCacheDirty;
 
+  /**
+   * Nix Epoch, incremented each time a flush is perfomed.
+   */
+  static uint32_t g_epoch;
+
   /** Cache stores nix-vectors based on destination ip */
   mutable NixMap_t m_nixCache;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/nix-vector-routing/test/nix-test.cc ns-3.36/src/nix-vector-routing/test/nix-test.cc
--- ns-3.35/src/nix-vector-routing/test/nix-test.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/nix-vector-routing/test/nix-test.cc	2022-04-30 18:23:58.118734800 -0700
@@ -117,12 +117,10 @@
 
 void NixVectorRoutingTest::ReceivePkt (Ptr<Socket> socket)
 {
-  uint32_t availableData;
-  availableData = socket->GetRxAvailable ();
+  [[maybe_unused]] uint32_t availableData = socket->GetRxAvailable ();
   m_receivedPacket = socket->Recv (std::numeric_limits<uint32_t>::max (), 0);
   NS_TEST_ASSERT_MSG_EQ (availableData, m_receivedPacket->GetSize (),
                          "availableData should be equal to the size of packet received.");
-  NS_UNUSED (availableData);
   m_receivedPacketSizes.push_back (m_receivedPacket->GetSize ());
 }
 
@@ -314,21 +312,21 @@
 
   // Test the Path
   const std::string p_nSrcnAnCnDstv4 = "Time: +3s, Nix Routing\n"
-                                              "Route Path: (Node 0 to Node 4, Nix Vector: 01001)\n"
+                                              "Route path from Node 0 to Node 4, Nix Vector: 01001 (5 bits left)\n"
                                               "10.1.0.1                 (Node 0)  ---->   10.1.0.2                 (Node 1)\n"
                                               "10.1.4.1                 (Node 1)  ---->   10.1.4.2                 (Node 3)\n"
                                               "10.1.3.1                 (Node 3)  ---->   10.1.3.2                 (Node 4)\n\n";
   NS_TEST_EXPECT_MSG_EQ (stringStream1v4.str (), p_nSrcnAnCnDstv4, "Routing Path is incorrect.");
 
   const std::string p_nSrcnAnCnDstv6 = "Time: +3s, Nix Routing\n"
-                                              "Route Path: (Node 0 to Node 4, Nix Vector: 01001)\n"
+                                              "Route path from Node 0 to Node 4, Nix Vector: 01001 (5 bits left)\n"
                                               "2001::200:ff:fe00:1      (Node 0)  ---->   fe80::200:ff:fe00:2      (Node 1)\n"
                                               "fe80::200:ff:fe00:9      (Node 1)  ---->   fe80::200:ff:fe00:a      (Node 3)\n"
                                               "fe80::200:ff:fe00:7      (Node 3)  ---->   2001:3::200:ff:fe00:8    (Node 4)\n\n";
   NS_TEST_EXPECT_MSG_EQ (stringStream1v6.str (), p_nSrcnAnCnDstv6, "Routing Path is incorrect.");
 
   const std::string p_nSrcnAnBnCnDstv4 = "Time: +9s, Nix Routing\n"
-                                                 "Route Path: (Node 0 to Node 4, Nix Vector: 0111)\n"
+                                                 "Route path from Node 0 to Node 4, Nix Vector: 0111 (4 bits left)\n"
                                                  "10.1.0.1                 (Node 0)  ---->   10.1.0.2                 (Node 1)\n"
                                                  "10.1.1.1                 (Node 1)  ---->   10.1.1.2                 (Node 2)\n"
                                                  "10.1.2.1                 (Node 2)  ---->   10.1.2.2                 (Node 3)\n"
@@ -336,7 +334,7 @@
   NS_TEST_EXPECT_MSG_EQ (stringStream3v4.str (), p_nSrcnAnBnCnDstv4, "Routing Path is incorrect.");
 
   const std::string p_nSrcnAnBnCnDstv6 = "Time: +9s, Nix Routing\n"
-                                                 "Route Path: (Node 0 to Node 4, Nix Vector: 0111)\n"
+                                                 "Route path from Node 0 to Node 4, Nix Vector: 0111 (4 bits left)\n"
                                                  "2001::200:ff:fe00:1      (Node 0)  ---->   fe80::200:ff:fe00:2      (Node 1)\n"
                                                  "fe80::200:ff:fe00:3      (Node 1)  ---->   fe80::200:ff:fe00:4      (Node 2)\n"
                                                  "fe80::200:ff:fe00:5      (Node 2)  ---->   fe80::200:ff:fe00:6      (Node 3)\n"
@@ -380,4 +378,4 @@
 };
 
 /// Static variable for test initialization
-static NixVectorRoutingTestSuite g_nixVectorRoutingTestSuite;
\ No newline at end of file
+static NixVectorRoutingTestSuite g_nixVectorRoutingTestSuite;
